#!/usr/bin/php
<?php

$gateway = 'http://indavideo.hu/amfphp2/gateway.php';

// These items are offered at the first level
$RSSCONFIG = array(
    array('name' => 'Index Videó', 
          'url'  => 'http://index.hu/video/rss',
          'desc' => 'Index video'),
    array('name' => 'Mozifilmek', 
          'url'  => 'http://film.indavideo.hu/rss/type/mozifilm',
          'desc' => 'Index video'),
    array('name' => 'Kisfilmek', 
          'url'  => 'http://film.indavideo.hu/rss/type/kisfilm',
          'desc' => 'Index video'),
    array('name' => 'Dokumentumfilmek', 
          'url'  => 'http://film.indavideo.hu/rss/type/dokfilm',
          'desc' => 'Index video'),
    array('name' => 'Természetfilmek', 
          'url'  => 'http://film.indavideo.hu/rss/type/termeszetfilm',
          'desc' => 'Index video'),
);

if (count($argv) < 4) {
    exit();
}

$url = $argv[2];
$stream_name = $argv[3];

chdir(dirname(__FILE__));

// This is to enshure we're detected as a bot
ini_set('user_agent', 'GoogleBot');

/********************* Main menu *****************************/
if (!preg_match('-/-', $url)) {
    $xml = new SimpleXMLElement('<?xml version="1.0" encoding="iso-8859-2" ?><items></items>'); 
    
    foreach ($RSSCONFIG as $rssitem) {
        $item = $xml->addChild('item');
        $item->addChild('name', $rssitem['name']);
        $item->addChild('url', $rssitem['url']);
        $item->addChild('desc', $rssitem['desc']);
        $item->addChild('handler', '*indexparser');
        $item->addChild('meta');
    }
    
    echo $xml->asXML();
    exit();
}
/********************* Handling rss parsing ******************/
elseif (preg_match('-/rss(/|$)-', $url)) {
    // parse rss
    $rss = new SimpleXMLElement($url, null, true);
    if (!$rss) die("Could not download rss url\n");
    
    $xml = new SimpleXMLElement('<?xml version="1.0" encoding="iso-8859-2" ?><items></items>'); 
    
    foreach ($rss->channel->item as $rssitem) {
        $item = $xml->addChild('item');
        $item->addChild('name', $rssitem->title);
        $item->addChild('url', $rssitem->link);
        $item->addChild('descr', str_replace('&', '&amp;', $rssitem->description));
        $item->addChild('handler', '*indexparser');
        $item->addChild('meta');
    }
    
    echo $xml->asXML();
    
    exit();
}

/******************** Handling url download ***********************/
define('AMFPHP_BASE', './core/');
require_once(AMFPHP_BASE.'shared/util/CompatPhp5.php');
require_once(AMFPHP_BASE.'shared/util/CharsetHandler.php');
require_once(AMFPHP_BASE.'amf/io/AMFDeserializer.php');
require_once(AMFPHP_BASE.'amf/io/AMFSerializer.php');
require_once(AMFPHP_BASE.'amf/util/AMFObject.php');



/** Id elokeresese **/

//*
$content = file_get_contents($url);
if (!$content) die("Could not load url\n");

if (!preg_match('/"flashvars",[\s]+"vID=([0-9a-f]+)/', $content, $regs)) die('Could not find video id');

$vid = $regs[1];
/*/

$vid = '8a9a616434';
//*/


// Create request object to amf gateway
$body = new MessageBody('hash_2_video.GetVideoValues.getVideo', '/1', array($vid, 's'));

$req = encodeRequest($body);

// Send request
$ctx = stream_context_create(array('http'=>array('method' => 'POST', 
                                                 'content' => $req)));

$data = file_get_contents($gateway, FILE_BINARY, $ctx);


$obj = new AMFObject();
$decoder = new AMFDeserializer($data);

$decoder->deserialize($obj);

$value = $obj->getBodyAt(0)->getValue();

if (!isset($value['VALUES']['video_flv'])) die('Could not get flv url');

$xml = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8" ?><items></items>');
$item = $xml->addChild('item');
$item->addChild('name', $stream_name);
$item->addChild('url', $value['VALUES']['video_flv']);
$item->addChild('desc', $value['VALUES']['video_title']);
$item->addChild('handler', 'STREAM_DL');
$item->addChild('meta');

echo $xml->asXML();


exit();
/****************************************************/


function encodeRequest($body) {
    $encoder = new AMFSerializer();
    $encoder->writeInt(3); //  write the version ???
    
    // Header
    $encoder->writeInt(0); // no headers sent
    
    // Body
    $encoder->writeInt(1); // one body sent
    $encoder->writeUTF($body->targetURI); // 
    $encoder->writeUTF($body->responseIndex);
    
    // I don't know what this is
    $encoder->writeByte(0);
    $encoder->writeByte(0);
    $encoder->writeByte(0);
    $encoder->writeByte(22);
    
    $encoder->writeArray($body->getValue());
    
    return $encoder->outBuffer;
}
